VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmDirect_SQL 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Direct SQL"
   ClientHeight    =   4605
   ClientLeft      =   1095
   ClientTop       =   1800
   ClientWidth     =   6720
   HelpContextID   =   42100
   Icon            =   "DIR_SQL.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4605
   ScaleWidth      =   6720
   Begin VB.TextBox txtSQL 
      BeginProperty Font 
         Name            =   "Times New Roman"
         Size            =   11.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3750
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Text            =   "DIR_SQL.frx":030A
      Top             =   0
      Width           =   6720
   End
   Begin VB.PictureBox SSPanel1 
      Align           =   2  'Align Bottom
      Height          =   780
      Left            =   0
      ScaleHeight     =   720
      ScaleWidth      =   6660
      TabIndex        =   1
      Top             =   3825
      Width           =   6720
      Begin VB.CommandButton CmdClose 
         Cancel          =   -1  'True
         Caption         =   "Close"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   465
         Left            =   4950
         TabIndex        =   4
         Top             =   135
         Width           =   1230
      End
      Begin VB.CommandButton cmdHelp 
         Caption         =   "Help"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   465
         Left            =   2610
         TabIndex        =   3
         Top             =   135
         Width           =   1230
      End
      Begin VB.CommandButton cmdExecute 
         Caption         =   "Execute"
         BeginProperty Font 
            Name            =   "MS Sans Serif"
            Size            =   8.25
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   465
         Left            =   315
         TabIndex        =   2
         Top             =   135
         Width           =   1230
      End
      Begin MSComDlg.CommonDialog SQL_Dialogue 
         Left            =   4230
         Top             =   270
         _ExtentX        =   847
         _ExtentY        =   847
         _Version        =   393216
      End
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuOpen 
         Caption         =   "Open"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "Save"
      End
      Begin VB.Menu Bar2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuBuild_sql 
         Caption         =   "Build SQL"
      End
      Begin VB.Menu Bar4 
         Caption         =   "-"
      End
      Begin VB.Menu mnuPrint 
         Caption         =   "Print"
      End
      Begin VB.Menu Bar1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuHelp 
         Caption         =   "Help"
      End
      Begin VB.Menu bar3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuClose 
         Caption         =   "Close"
      End
   End
End
Attribute VB_Name = "frmDirect_SQL"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Public mySQL As String
Private Loading As Boolean

Private Sub cmdClose_Click()
    On Local Error GoTo Error_handler
    Unload Me
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume

End Sub

Private Sub cmdExecute_Click()
    On Local Error GoTo Error_handler
    txtSQL.Text = Strip_carriage_returns_and_spaces(txtSQL.Text)
    If Syntax_check Then
        If Compile_sql Then
            Show_result
        End If
    End If
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume
        
End Sub

Private Sub cmdHelp_Click()
    Show_help (42100)
End Sub

Private Sub Form_Activate()
    On Local Error GoTo Error_handler
    If Loading Then
        Set HelpDialogue = Me.SQL_Dialogue
        App.HelpFile = App.Path + "\libra.hlp"
        Declare_variables
    
        Set MyWorkspace = DBEngine.Workspaces(0)
        Set Libra = MyWorkspace.OpenDatabase _
                (Get_ini_data("Libra_db_path"))
        Set Transaction_db = MyWorkspace.OpenDatabase _
                (Get_ini_data("Transac_db_path"))
        Set Setup = Libra.OpenRecordset("setup table")
        Set User_log = Transaction_db.OpenRecordset("user's log")
        
        Load frmEnter_password
        With frmEnter_password
            .Top = Me.Top + (Me.Height / 2) - (.Height / 2)
            .Left = Me.Left + (Me.Width / 2) - (.Width / 2)
        End With
        
        Check_security
        Initialise_security
        If Allow_Querying Then
            Log_in_user (8)
        Else
            msg$ = "You are not authorised to carry out querying operations."
            MsgBox msg$, vbCritical, "Security violation"
            Unload Me
        End If
        Loading = False
    End If

Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume
    
End Sub

Private Sub Form_Load()
    On Local Error GoTo Error_handler
    If App.PrevInstance Then
        msg$ = "Another copy of this Librarius 2000 Query facility is already running."
        MsgBox msg$, vbCritical, "Direct SQL"
    Else
        Loading = True
    End If
        
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume

End Sub

Private Sub Form_Resize()
    On Local Error GoTo Error_handler
    txtSQL.Left = Me.ScaleLeft
    txtSQL.Width = Me.ScaleWidth
    txtSQL.Top = Me.ScaleTop
    If (Me.ScaleHeight - SSPanel1.Height) > 0 Then
        txtSQL.Height = Me.ScaleHeight - SSPanel1.Height
    End If
    txtSQL.Refresh
    Me.Refresh
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Log_out_user
    End
End Sub

Private Sub mnuBuild_sql_Click()
    On Local Error GoTo Error_handler
    cmdExecute.Value = True
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume

End Sub

Private Sub mnuClose_Click()
    On Local Error GoTo Error_handler
    cmdClose.Value = True
Exit Sub

Error_handler:
    Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
    If Response = vbRetry Then
        Resume
    Else
        Exit Sub
    End If
Resume

End Sub

Private Function Syntax_check()
    
    mySQL = UCase(Trim(txtSQL.Text))
    
    If mySQL = "" Then
        msg$ = "Enter SQL"
    ElseIf Left(mySQL, 6) <> "SELECT" Then
        msg$ = "SQL must start with SELECT"
    ElseIf InStr(1, mySQL, " INTO ", 1) <> 0 Then
        msg$ = "You cannot specify a make table query."
    End If
    
    If msg$ <> "" Then
        Buttons = vbOKOnly + vbExclamation
        MsgBox msg$, Buttons, "Protocol Error"
        Syntax_check = False
    Else
        Syntax_check = True
    End If
        
End Function

Private Function Compile_sql()
    On Local Error GoTo ErrorHandler
    Dim First_try As Boolean
    
    First_try = True
    Set Direct_SQL = Libra.QueryDefs("Direct Sql Query")
    Direct_SQL.SQL = mySQL
    Set SQL_result = Direct_SQL.OpenRecordset()
    
    Screen.MousePointer = 11
    Direct_SQL.SQL = mySQL
    Set SQL_result = Direct_SQL.OpenRecordset()
    Compile_sql = True
    Screen.MousePointer = 0

Exit Function

ErrorHandler:
    
    If First_try And Err.Number = 3078 Then
        'The table is first checked in the main database and if it is not
        'found, another search is carried out in the transaction DB before
        'the table is registered as non-existend.
        Set Direct_SQL = Transaction_db.QueryDefs("Direct Sql Query")
        First_try = False
        Direct_SQL.SQL = mySQL
        Resume
    Else
        Compile_sql = False
        msg$ = "Compiling Error : " + Err.description
        Buttons = vbOKOnly + vbExclamation
        MsgBox msg$, Buttons, "Error"
        Screen.MousePointer = 0
        Exit Function
    End If
Resume

    
End Function

Private Sub Show_result()
    Screen.MousePointer = 11
    If SQL_result.RecordCount = 0 Then
        msg$ = "No records returned"
        Buttons = vbOKOnly + vbExclamation
        MsgBox msg$, Buttons, "Librarius 2000 SQL"
    Else
        frmSQL_results.Show 1
    End If
    Screen.MousePointer = 0
End Sub

Private Sub mnuHelp_Click()
    cmdHelp.Value = True
End Sub

Private Sub mnuOpen_Click()
    Dim Temp As String
    On Local Error GoTo Error_handler
    With SQL_Dialogue
        .DialogTitle = "Open SQL Text"
        .Filter = "Sql Files (*.sql)|*.sql|Text Files (*.TXT)|*.txt"
        .FilterIndex = 1
        .Flags = cdlOFNFileMustExist + cdlOFNHideReadOnly
        .CancelError = True
        .ShowOpen
    End With
    
    
    myFileName$ = SQL_Dialogue.FileName
    If FileLen(myFileName$) > 30000 Then
        msg$ = "This file is too long to be opened for SQL purposes."
        Buttons = vbOKOnly + vbexlamation
        MsgBox msg$, Buttons, "Open SQL File"
    Else
        myHandle = FreeFile
        txtSQL.Text = ""
        Open myFileName$ For Input As myHandle
            While Not (EOF(myHandle))
                Line Input #1, Temp
                txtSQL.Text = txtSQL.Text + Chr(13) + Chr(10) + Temp
            Wend
        Close myHandle
    
        
    End If
        
Exit Sub

Error_handler:
    If Err.Number = cdlCancel Then
        Exit Sub
    Else
        Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
        If Response = vbRetry Then
            Resume
        Else
            Exit Sub
        End If
    End If
Resume

End Sub

Private Sub mnuPrint_Click()
    Dim PrintText As String
    On Local Error GoTo Error_handler
    
    With SQL_Dialogue
        .PrinterDefault = True
        .Flags = cdlPDHidePrintToFile + cdlPDReturnDC + cdlPDNoPageNums
        .CancelError = True
        .ShowPrinter
    End With
    
    If (SQL_Dialogue.Flags) And cdlPDSelection Then
        If txtSQL.SelText = "" Then
            Buttons = vbOKOnly + vbExclamation
            msg$ = "No text has been selected for printing."
            MsgBox msg$, Buttons, "Print SQL"
            Exit Sub
        Else
            PrintText = txtSQL.SelText
        End If
    Else
        PrintText = txtSQL.Text
    End If
    
    
    Printer.Font.Name = txtSQL.Font.Name
    Printer.Font.Size = txtSQL.Font.Size
    Printer.Print PrintText
    Printer.EndDoc
    
Exit Sub

Error_handler:
    If Err.Number = cdlCancel Then
        Exit Sub
    Else
        Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
        If Response = vbRetry Then
            Resume
        Else
            Exit Sub
        End If
    End If
Resume

End Sub

Private Sub mnuSave_Click()
    On Local Error GoTo Error_handler
    With SQL_Dialogue
        .DialogTitle = "Save SQL Text"
        .Filter = "Sql Files (*.sql)|*.sql|Text Files (*.TXT)|*.txt"
        .FilterIndex = 1
        .Flags = cdlOFNPathMustExist + cdlOFNHideReadOnly + cdlOFNOverwritePrompt
        .CancelError = True
        .ShowSave
    End With
    
    
    myFileName$ = SQL_Dialogue.FileName
    myHandle = FreeFile
    Open myFileName$ For Output As myHandle
        Print #1, txtSQL.Text
    Close myHandle
    
Exit Sub

Error_handler:
    If Err.Number = cdlCancel Then
        Exit Sub
    Else
        Response = MsgBox(Err.description, vbRetryCancel + vbExclamation, "Error")
        If Response = vbRetry Then
            Resume
        Else
            Exit Sub
        End If
    End If
Resume


End Sub

Private Function Strip_carriage_returns_and_spaces(mySQL As String) As String
    
    mySQL = Trim(mySQL)
    Do
        If Len(mySQL) > 0 Then
            Character = Left(mySQL, 1)
            If Asc(Character) = 13 Or Asc(Character) = 9 Or _
               Asc(Character) = 10 Or Asc(Character) = 32 Then
                    If Len(mySQL) > 1 Then
                        Let mySQL = Mid(mySQL, 2, Len(mySQL))
                    Else
                        mySQL = ""
                    End If
            Else
                Exit Do
            End If
        Else
            Exit Do
        End If
    Loop
    Strip_carriage_returns_and_spaces = mySQL
End Function
